###############################################################################
#
# <p>Amazon Web Service Ƹ</p>
# <pre>
#   {{amazonsearch ,b,5,l}}
# </pre>
# <p>
#   word
#   genre
#    a:Blended
#    b:Books
#    c:Classical
#    d:DVD
#    e:Electronics
#    f:ForeignBooks
#    h:Hobbies
#    k:Kitchen
#    l:HealthPersonalCare
#    m:Music
#    p:SportingGoods
#    s:Software
#    t:Toys
#    v:VideoGames
#   number
#    default:1
#    max:10
#   imagesize
#    s,m,l
#    default:s
# </p>
#
###############################################################################
package plugin::amazonsearch::AmazonSearch;
use AmazonPAPI;
use LWP::UserAgent;
use XML::Simple;
use Unicode::RecursiveDowngrade;
use Encode qw/from_to/;

#==============================================================================
# 󥹥ȥ饯
#==============================================================================
sub new {
  my $class = shift;
  my $self = {};
  return bless $self,$class;
}
#==============================================================================
# ѥ饰ե᥽å
#==============================================================================
sub paragraph {
  my $self = shift;
  my $wiki = shift;
  my $word = shift;
  my $opt = shift;
  my $num = shift;
  my $size = shift;

  my $buf = "<div class=\"amazonsearch\">";
  $buf .= &search($word,$opt,$num,$size);
  $buf .= "</div>";

  return $buf;
}


sub search {
  my $word = shift;
  my $opt = shift;
  my $num = shift;
  my $size = shift;

  my $xml;

  my %genre = (
    "a" => 'Blended',
    "b" => 'Books',
    "c" => 'Classical',
    "d" => 'DVD',
    "e" => 'Electronics',
    "f" => 'ForeignBooks',
    "h" => 'Hobbies',
    "k" => 'Kitchen',
    "l" => 'HealthPersonalCare',
    "m" => 'Music',
    "p" => 'SportingGoods',
    "s" => 'Software',
    "t" => 'Toys',
    "v" => 'VideoGames',
    );

  my %imagesize = (
    "s" => 'SmallImage',
    "m" => 'MediumImage',
    "l" => 'LargeImage',
    );

  my $AccessKeyId = 'XXXXXXXXXXXXXXXXXXXX';
  my $SecretAccessKey = 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx';
  my $AssociateTag = "XXXXXXXXXX";

  my $UserAgent = 'ECSReader/0.1';
  my $ResponseGroup = 'Small,Images';

  from_to($word,"euc-jp","utf8");
  $word =~ s/\'/sprintf("%%%02X",ord($1))/seg;

  if(($opt eq "") || !(exists($genre{$opt}))){
    $opt = "a";
  }
  $opt = $genre{$opt};

  if($num eq ""){
    $num = 1;
  }

  if(($size eq "") || !(exists($imagesize{$size}))){
    $size = "s";
  }
  $size = $imagesize{$size};

  my $aws = new AmazonPAPI({
      'AWSAccessKeyId' => $AccessKeyId,
      'AWSSecretKey'   => $SecretAccessKey,
      'AssociateTag'   => $AssociateTag,
  });

  my $res = $aws->request('ItemSearch',{
      'Keywords' => $word,
      'SearchIndex' => $opt,
      'ResponseGroup' => $ResponseGroup,
  });

  if($res){
    my $rd = Unicode::RecursiveDowngrade->new;
    $xml = $rd->downgrade(XMLin($res,ForceArray => 1));
  }

  my $buf = "<table>";

  my $items = $xml->{Items}->[0]{Item};

  if($items){
    $count = 1;
    for my $item (@{$items}){
      my $image_url = $item->{ImageSets}->[0]{ImageSet}->[0]{$size}->[0]{URL}->[0];
      my $asin = $item->{ASIN}->[0];
      my $title = $item->{ItemAttributes}->[0]{Title}->[0];
      my $detail = $item->{DetailPageURL}->[0];
      my $manufacturer = $item->{ItemAttributes}->[0]{Manufacturer}->[0];
      my $author = $item->{ItemAttributes}->[0]{Author}->[0];
      my $artist = $item->{ItemAttributes}->[0]{Artist}->[0];

      my $other_image_url = "./plugin/amazonsearch/no_image.jpg";

      $buf .= "<tr><td rowspan=\"5\">";
      if($image_url){
        $buf .= "<a href=\"$detail\"><img src=\"$image_url\"></a>";
      }else{
        $buf .= "<a href=\"$detail\"><img src=\"$other_image_url\"></a>";
      }
      $buf .= "</td></tr><tr><td><a href=\"$detail\">$title</a></td></tr>";
      $buf .= "<tr><td>$manufacturer</td></tr>";
      $buf .= "<tr><td>$author</td></tr>";
      $buf .= "<tr><td>$artist</td></tr>";
      if($count >= $num){
        last;
      }
      $count++;
    }
    $buf .= "</table>";
  }else{
    $buf .= "<p><span class=\"error\">No Item.</span></p>";
    $buf .= "</table>";
#    return Util::paragraph_error('뾦ʤޤ');
  }

  &Jcode::convert(\$buf ,'utf8');
  from_to($buf,"utf8","euc-jp");

  return $buf;
}

1;
